"Use strict";
import powerbi from "powerbi-visuals-api";
import DataView = powerbi.DataView;
import {VisualSettings} from "../settings/visualSettings";
import * as d3 from "d3";
type Selection<T extends d3.BaseType> = d3.Selection<T, any, any, any>;
/*
Main interfaces
*/

//ISelectorManager
export interface ILayoutManager{
    layout:Selection<HTMLElement>;
    update(dataView:DataView):void;
}
export interface ILayoutManagerConstructor{
    new(layout:Selection<HTMLElement>):ILayoutManager;
};

//ISelectorManager
export interface ISelectorManager{
    selectorContainer:Selection<HTMLElement>;
    updateView(categories:powerbi.DataViewCategoryColumn,defaultSelect:powerbi.DataViewValueColumn,defaultStart:powerbi.DataViewValueColumn,defaultEnd:powerbi.DataViewValueColumn);
}
export interface ISelectorManagerConstructor{
    new(selectorContainer:Selection<HTMLElement>):ISelectorManager;
}

//IFilterManager
export interface IFilterManager{
    applyFilter():void;
    setJsonFilter(field:Text|number,select: Text|number):void;
    setJsonFilter(field:number,start:number,end:number):void;
    setJsonFitler(filter:Date,select:Date):void;
}
export interface IFilterManagerConstructor{
    new(host:powerbi.extensibility.IVisualHost);
}
